diff -cr gcc-2.4/aux-outp.c d:gcc-2.4/aux-outp.c
*** gcc-2.4/aux-outp.c	Sun Jul 11 12:58:52 1993
--- d:gcc-2.4/aux-outp.c	Wed Jun 23 23:23:16 1993
***************
*** 1,3 ****
--- 1,5 ----
+ /* aux-outp.c -- changed for emx by Eberhard Mattes -- Jun 1993 */
+ 
  /* Subroutines for insn-output.c for Intel 80386.
     Copyright (C) 1988, 1992 Free Software Foundation, Inc.
  
***************
*** 701,707 ****
--- 703,713 ----
  {
    register int regno;
    int limit;
+ #ifndef EMX
    rtx xops[4];
+ #else /* EMX */
+   rtx xops[5];
+ #endif /* EMX */
    int pic_reg_used = flag_pic && (current_function_uses_pic_offset_table
  				  || current_function_uses_const_pool);
  
***************
*** 715,721 ****
--- 721,755 ----
      }
  
    if (size)
+ #ifndef EMX
      output_asm_insn (AS2 (sub%L0,%2,%0), xops);
+ #else /* EMX */
+     {
+       if (TARGET_PROBE && size >= PROBE_SIZE)
+         {
+         if (size > PROBE_MAX_INLINE)
+           {
+             output_asm_insn (AS1 (push%L0,%2), xops);
+             output_asm_insn (AS1 (call,___probe), xops);
+           }
+         else
+           {
+             int i = size, j = 0;
+             xops[3] = const0_rtx;
+             while (i >= PROBE_SIZE)
+               {
+                 i -= PROBE_SIZE; j += PROBE_SIZE;
+                 xops[4] = gen_rtx (MEM, QImode,
+                             gen_rtx (PLUS, SImode,
+                               gen_rtx (REG, SImode, 7),
+                               gen_rtx (CONST_INT, VOIDmode, -j)));
+                 output_asm_insn (AS2 (movb,%3,%4), xops);
+               }
+           }
+         }
+       output_asm_insn (AS2 (sub%L0,%2,%0), xops);
+     }
+ #endif /* EMX */
  
    /* Note If use enter it is NOT reversed args.
       This one is not reversed from intel!!
diff -cr gcc-2.4/cccp.c d:gcc-2.4/cccp.c
*** gcc-2.4/cccp.c	Sat May 22 00:13:16 1993
--- d:gcc-2.4/cccp.c	Sun Jul 11 12:27:50 1993
***************
*** 1,3 ****
--- 1,5 ----
+ /* cccp.c -- changed for emx by Eberhard Mattes -- Jun 1993 */
+ 
  /* C Compatible Compiler Preprocessor (CCCP)
  Copyright (C) 1986, 1987, 1989, 1992 Free Software Foundation, Inc.
                      Written by Paul Rubin, June 1986
***************
*** 365,370 ****
--- 367,380 ----
  
  static int print_deps = 0;
  
+ #ifdef EMX
+ /* Nonzero means use .obj instead of .o for target file when printing
+    dependencies. */
+ 
+ static int omf = 0;
+ 
+ #endif
+ 
  /* Nonzero means print names of header files (-H).  */
  
  static int print_include_names = 0;
***************
*** 1405,1410 ****
--- 1415,1432 ----
  	inhibit_predefs = 1;
  	break;
  
+ #ifdef EMX
+       case 'Z':
+         if (!strcmp (argv[i], "-Zomf"))
+           omf = 1;
+         else if (!strcmp (argv[i], "-Zc++-comments")
+                  || !strcmp (argv[i], "-ZC++-comments"))
+           cplusplus_comments = 1;
+         else
+           fatal ("Invalid option `%s'", argv[i]);
+         break;
+ #endif /* EMX */
+ 
        case '\0': /* JF handle '-' as file name meaning stdin or stdout */
  	if (in_fname == NULL) {
  	  in_fname = "";
***************
*** 1778,1784 ****
--- 1800,1810 ----
  	deps_output (p, 0);
        /* Supply our own suffix.  */
  #ifndef VMS
+ #ifndef EMX
        deps_output (".o : ", 0);
+ #else /* EMX */
+       deps_output (omf ? ".obj : " : ".o : ", 0);
+ #endif /* EMX */
  #else
        deps_output (".obj : ", 0);
  #endif
***************
*** 3921,3927 ****
--- 3947,3957 ----
  
    /* If specified file name is absolute, just open it.  */
  
+ #ifndef EMX
    if (*fbeg == '/') {
+ #else /* EMX */
+   if (*fbeg == '/' || *fbeg == '\\' || _fngetdrive (fbeg) != 0) {
+ #endif /* EMX */
      strncpy (fname, fbeg, flen);
      fname[flen] = 0;
      if (redundant_include_p (fname))
diff -cr gcc-2.4/cp-lex.c d:gcc-2.4/cp-lex.c
*** gcc-2.4/cp-lex.c	Fri Apr 30 02:45:28 1993
--- d:gcc-2.4/cp-lex.c	Fri Jun 11 14:17:10 1993
***************
*** 1,3 ****
--- 1,5 ----
+ /* cp-lex.c -- changed for emx by Eberhard Mattes -- Jun 1993 */
+ 
  /* Separate lexical analyzer for GNU C++.
     Copyright (C) 1987, 1989, 1992, 1993 Free Software Foundation, Inc.
     Hacked by Michael Tiemann (tiemann@cygnus.com)
***************
*** 2048,2053 ****
--- 2050,2109 ----
  		      TREE_INT_CST_HIGH (fileinfo) = interface_unknown;
  		    }
  		}
+ #ifdef EMX
+               else if (c == 'p'
+                        && getch () == 'a'
+                        && getch () == 'c'
+ 		       && getch () == 'k')
+                 {
+                   int align;
+                   extern int maximum_field_alignment;
+ 
+                   align = -1;
+                   do
+                     {
+                       nextchar = getch ();
+                     } while (nextchar == ' ' || nextchar == '\t');
+                   if (nextchar == '(')
+                     {
+                       do
+                         {
+                           nextchar = getch ();
+                         } while (nextchar == ' ' || nextchar == '\t');
+                       switch (nextchar)
+                         {
+                         case ')':
+                           align = 0;
+                           break;
+                         case '1':
+                         case '2':
+                         case '4':
+                           align = nextchar - '0';
+                           break;
+                         }
+                       if (nextchar != ')')
+                         do
+                           {
+                             nextchar = getch ();
+                           } while (nextchar == ' ' || nextchar == '\t');
+                       if (nextchar != ')')
+                         align = -1;
+                     }
+                   if (align < 0)
+                     {
+                       error ("invalid #pragma pack");
+                       goto skipline;
+                     }
+                   maximum_field_alignment = align * 8;
+                   do
+                     {
+                       nextchar = getch ();
+                     } while (nextchar == ' ' || nextchar == '\t');
+                   c = nextchar;
+ 		  if (c != '\n')
+ 		    warning ("trailing characters ignored");
+ 		}
+ #endif /* EMX */
  	    }
  	  goto skipline;
  	}
diff -cr gcc-2.4/explow.c d:gcc-2.4/explow.c
*** gcc-2.4/explow.c	Mon Apr 12 20:47:22 1993
--- d:gcc-2.4/explow.c	Fri Jun 11 14:17:10 1993
***************
*** 1,3 ****
--- 1,5 ----
+ /* explow.c -- changed for emx by Eberhard Mattes -- Jun 1993 */
+ 
  /* Subroutines for manipulating rtx's in semantically interesting ways.
     Copyright (C) 1987, 1991 Free Software Foundation, Inc.
  
***************
*** 638,643 ****
--- 640,680 ----
    if (adjust == const0_rtx)
      return;
  
+ #ifdef EMX
+   if (TARGET_PROBE &&
+           (GET_CODE (adjust) != CONST_INT || INTVAL (adjust) >= PROBE_SIZE))
+     {
+       int i, j;
+ 
+       if (GET_CODE (adjust) == CONST_INT && INTVAL (adjust) <= PROBE_MAX_INLINE)
+         {
+           i = INTVAL (adjust); j = 0;
+           while (i >= PROBE_SIZE)
+             {
+               i -= PROBE_SIZE; j += PROBE_SIZE;
+ /* (set (mem:QI (plus:SI (reg:SI 7) (const_int -j)) (const_int 0))) */
+               emit_insn (gen_rtx (SET, VOIDmode,
+                            gen_rtx (MEM, QImode,
+                              gen_rtx (PLUS, Pmode,
+                                gen_rtx (REG, Pmode, 7), /* esp */
+                                gen_rtx (CONST_INT, SImode, -j))),
+                            const0_rtx));
+             }
+         }
+       else
+         {
+           emit_push_insn (adjust, SImode, 0, 0, 0, 0, 0, 0, 0, 0);
+ /* (call (mem:QI (symbol_ref:SI ("__probe"))) (const_int 1)) */
+           emit_insn (gen_rtx (CALL, VOIDmode,
+                        gen_rtx (MEM, QImode,
+                          gen_rtx (SYMBOL_REF, Pmode, "__probe")),
+                        const1_rtx));
+           /*
+           emit_insn (gen_rtx (ASM_INPUT, VOIDmode, "call ___probe"));
+           */
+         }
+     }
+ #endif /* EMX */
    temp = expand_binop (Pmode,
  #ifdef STACK_GROWS_DOWNWARD
  		       sub_optab,
diff -cr gcc-2.4/gcc.c d:gcc-2.4/gcc.c
*** gcc-2.4/gcc.c	Mon Jun 07 04:45:56 1993
--- d:gcc-2.4/gcc.c	Wed Jul 07 22:35:58 1993
***************
*** 1,3 ****
--- 1,5 ----
+ /* gcc.c -- changed for emx by Eberhard Mattes -- Jun 1993 */
+ 
  /* Compiler driver program that can handle many languages.
     Copyright (C) 1987, 1989, 1992 Free Software Foundation, Inc.
  
***************
*** 65,70 ****
--- 67,77 ----
  #define NULL_PTR ((GENERIC_PTR)0)
  #endif
  
+ #ifdef EMX
+ #include <process.h>
+ extern char *_getname();
+ #endif /* EMX */
+ 
  #ifdef USG
  #define vfork fork
  #endif /* USG */
***************
*** 298,303 ****
--- 305,321 ----
  treated as compiler output files, and passed to the linker in their
  proper position among the other output files.  */
  
+ #ifndef EMX
+ 
+ #define EMX_ASM_SPEC_PATCH "%{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o} "
+ 
+ #else /* EMX */
+ 
+ #define EMX_ASM_SPEC_PATCH "%{Zomf:-o %d%g.o}%{!Zomf:\
+ 		            %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o}} "
+ 
+ #endif /* EMX */
+ 
  /* Define the macros used for specs %a, %l, %L, %S, %c, %C, %1.  */
  
  /* config.h can define ASM_SPEC to provide extra args to the assembler
***************
*** 453,461 ****
  		   %{aux-info*}\
  		   %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  		   %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!               %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
! 		      %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o}\
!                       %{!pipe:%g.s} %A\n }}}}"},
    {"-",
     "%{E:cpp -lang-c %{nostdinc*} %{C} %{v} %{A*} %{I*} %{P} %I\
  	%{C:%{!E:%eGNU C does not support -C without using -E}}\
--- 471,479 ----
  		   %{aux-info*}\
  		   %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  		   %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!               %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
!                       EMX_ASM_SPEC_PATCH
!                       "%{!pipe:%g.s} %A\n }}}}"},
    {"-",
     "%{E:cpp -lang-c %{nostdinc*} %{C} %{v} %{A*} %{I*} %{P} %I\
  	%{C:%{!E:%eGNU C does not support -C without using -E}}\
***************
*** 486,494 ****
  		   %{aux-info*}\
  		   %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  		   %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!               %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
! 		      %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o}\
!                       %{!pipe:%g.s} %A\n }}}}"},
    {".h", "@c-header"},
    {"@c-header",
     "%{!E:%eCompilation of header file requested} \
--- 504,512 ----
  		   %{aux-info*}\
  		   %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  		   %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!               %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
! 		      EMX_ASM_SPEC_PATCH
!                       "%{!pipe:%g.s} %A\n }}}}"},
    {".h", "@c-header"},
    {"@c-header",
     "%{!E:%eCompilation of header file requested} \
***************
*** 503,508 ****
--- 521,529 ----
          %i %W{o*}"},
    {".cc", "@c++"},
    {".cxx", "@c++"},
+ #ifdef EMX
+   {".cpp", "@c++"},
+ #endif
    {".C", "@c++"},
    {"@c++",
     "cpp -lang-c++ %{nostdinc*} %{C} %{v} %{A*} %{I*} %{P} %I\
***************
*** 521,529 ****
  		   %{aux-info*}\
  		   %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  		   %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!               %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
! 		      %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o}\
!                       %{!pipe:%g.s} %A\n }}}}"},
    {".i", "@cpp-output"},
    {"@cpp-output",
     "cc1 %i %1 %{!Q:-quiet} %{d*} %{m*} %{a}\
--- 542,550 ----
  		   %{aux-info*}\
  		   %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  		   %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!               %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
! 		      EMX_ASM_SPEC_PATCH
!                       "%{!pipe:%g.s} %A\n }}}}"},
    {".i", "@cpp-output"},
    {"@cpp-output",
     "cc1 %i %1 %{!Q:-quiet} %{d*} %{m*} %{a}\
***************
*** 532,539 ****
  	%{aux-info*}\
  	%{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  	%{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!     %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
!             %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o} %{!pipe:%g.s} %A\n }"},
    {".ii", "@c++-cpp-output"},
    {"@c++-cpp-output",
     "cc1plus %i %1 %2 %{!Q:-quiet} %{d*} %{m*} %{a}\
--- 553,561 ----
  	%{aux-info*}\
  	%{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  	%{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!     %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
!             EMX_ASM_SPEC_PATCH
!             "%{!pipe:%g.s} %A\n }"},
    {".ii", "@c++-cpp-output"},
    {"@c++-cpp-output",
     "cc1plus %i %1 %2 %{!Q:-quiet} %{d*} %{m*} %{a}\
***************
*** 542,554 ****
  	    %{aux-info*}\
  	    %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  	    %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!        %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
! 	       %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o}\
! 	       %{!pipe:%g.s} %A\n }"},
    {".s", "@assembler"},
    {"@assembler",
!    "%{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
!             %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o} %i %A\n }"},
    {".S", "@assembler-with-cpp"},
    {"@assembler-with-cpp",
     "cpp -lang-asm %{nostdinc*} %{C} %{v} %{A*} %{I*} %{P} %I\
--- 564,575 ----
  	    %{aux-info*}\
  	    %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  	    %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!        %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
! 	       EMX_ASM_SPEC_PATCH "%{!pipe:%g.s} %A\n }"},
    {".s", "@assembler"},
    {"@assembler",
!    "%{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
!             EMX_ASM_SPEC_PATCH "%i %A\n }"},
    {".S", "@assembler-with-cpp"},
    {"@assembler-with-cpp",
     "cpp -lang-asm %{nostdinc*} %{C} %{v} %{A*} %{I*} %{P} %I\
***************
*** 559,567 ****
          %{traditional-cpp:-traditional}\
  	%{g*} %{W*} %{w} %{pedantic*} %{H} %{d*} %C %{D*} %{U*} %{i*}\
          %i %{!M:%{!MM:%{!E:%{!pipe:%g.s}}}}%{E:%W{o*}}%{M:%W{o*}}%{MM:%W{o*}} |\n",
!    "%{!M:%{!MM:%{!E:%{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
!                     %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o}\
! 		    %{!pipe:%g.s} %A\n }}}}"},
    /* Mark end of table */
    {0, 0}
  };
--- 580,588 ----
          %{traditional-cpp:-traditional}\
  	%{g*} %{W*} %{w} %{pedantic*} %{H} %{d*} %C %{D*} %{U*} %{i*}\
          %i %{!M:%{!MM:%{!E:%{!pipe:%g.s}}}}%{E:%W{o*}}%{M:%W{o*}}%{MM:%W{o*}} |\n",
!    "%{!M:%{!MM:%{!E:%{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
!                     EMX_ASM_SPEC_PATCH
! 		    "%{!pipe:%g.s} %A\n }}}}"},
    /* Mark end of table */
    {0, 0}
  };
***************
*** 595,606 ****
--- 616,641 ----
  			%{L*} %o %{!nostdlib:libgcc.a%s %L libgcc.a%s %{!A:%E}}\n }}}}}}";
  #else
  /* Use -L and have the linker do the search for -lgcc.  */
+ #ifndef EMX
  static char *link_command_spec = "\
  %{!fsyntax-only: \
   %{!c:%{!M:%{!MM:%{!E:%{!S:ld %l %X %{o*} %{A} %{d} %{e*} %{m} %{N} %{n} \
  			%{r} %{s} %{T*} %{t} %{u*} %{x} %{z}\
  			%{!A:%{!nostartfiles:%{!nostdlib:%S}}} %{static:}\
  			%{L*} %D %o %{!nostdlib:-lgcc %L -lgcc %{!A:%E}}\n }}}}}}";
+ #else /* EMX */
+ static char *link_command_spec = "\
+ %{!c:%{!M:%{!MM:%{!E:%{!S:%{Zomf:emxomf}ld %l %X %{o*} %{A} %{d} %{e*} %{m} %{N} %{n} \
+ 			%{r} %{s} %{T*} %{t} %{u*} %{x} %{z} %{Zexe} \
+ 			%{Zstack*} \
+ 			%{!A:%{!nostdlib:%S}} \
+ 			%{L*} %D %o %{!nostdlib:%{Zmtd:-lcdll -los2 -lemx2} \
+                         %{!Zmtd:-lgcc %L -lgcc \
+                         %{Zsys:%{!Zmts:-lsysst}%{Zmts:-lsysmt} -los2} \
+                         %{!Zsys:%{!Zmts:-lemxst}%{Zmts:-lemxmt} \
+                         -los2 -lemx2}} \
+                         %{!A:%E}}\n }}}}}";
+ #endif /* EMX */
  #endif
  #endif
  
***************
*** 1348,1364 ****
--- 1383,1407 ----
  #endif
        if (base == (char *)0)
  	{
+ #ifndef EMX
  	  if (access ("/usr/tmp", R_OK | W_OK) == 0)
  	    base = "/usr/tmp/";
  	  else
  	    base = "/tmp/";
+ #else /* EMX */
+ 	  base = "./";
+ #endif /* EMX */
  	}
      }
  
    len = strlen (base);
    temp_filename = xmalloc (len + sizeof("/ccXXXXXX"));
    strcpy (temp_filename, base);
+ #ifndef EMX
    if (len > 0 && temp_filename[len-1] != '/')
+ #else /* EMX */
+   if (len > 0 && temp_filename[len-1] != '/' && temp_filename[len-1] != '\\')
+ #endif /* EMX */
      temp_filename[len++] = '/';
    strcpy (temp_filename + len, "ccXXXXXX");
  
***************
*** 1753,1758 ****
--- 1796,1833 ----
  
  #else /* not __MSDOS__ */
  
+ #ifdef EMX
+ 
+ static int
+ pexecute (search_flag, program, argv, not_last)
+      int search_flag;
+      char *program;
+      char *argv[];
+      int not_last;
+ {
+   int rc;
+   int input_desc = last_pipe_input;
+   int output_desc = STDOUT_FILE_NO;
+ 
+   /* If this isn't the last process, make a pipe for its output,
+      and record it as waiting to be the input to the next process.  */
+ 
+   if (not_last)
+     {
+       fprintf (stderr, "gcc: pipes not supported\n");
+       exit (250);
+     }
+   else
+     last_pipe_input = STDIN_FILE_NO;
+   rc = (search_flag ? spawnv : spawnvp) (P_WAIT, program,
+                                          (char const * const *)argv);
+   if (rc < 0)
+       pfatal_with_name (program);
+   return rc;
+ }
+ 
+ #else /* !EMX */
+ 
  static int
  pexecute (search_flag, program, argv, not_last)
       int search_flag;
***************
*** 1841,1846 ****
--- 1916,1922 ----
      }
  }
  
+ #endif /* !EMX */
  #endif /* not __MSDOS__ */
  #else /* not OS2 */
  
***************
*** 1865,1877 ****
--- 1941,1958 ----
  execute ()
  {
    int i;
+ #ifdef EMX
+   int rc, ret_code;
+ #endif /* EMX */
    int n_commands;		/* # of command.  */
    char *string;
    struct command
      {
        char *prog;		/* program name.  */
        char **argv;		/* vector of args.  */
+ #ifndef EMX
        int pid;			/* pid of process for this command.  */
+ #endif /* !EMX */
      };
  
    struct command *commands;	/* each command buffer with above info.  */
***************
*** 1944,1963 ****
--- 2025,2058 ----
    /* Run each piped subprocess.  */
  
    last_pipe_input = STDIN_FILE_NO;
+ #ifdef EMX
+   ret_code = 0;
+ #endif /* EMX */
    for (i = 0; i < n_commands; i++)
      {
        char *string = commands[i].argv[0];
  
+ #ifndef EMX
        commands[i].pid = pexecute (string != commands[i].prog,
  				  string, commands[i].argv,
  				  i + 1 < n_commands);
+ #else /* EMX */
+       rc = pexecute (string != commands[i].prog,
+                      string, commands[i].argv,
+                      i + 1 < n_commands);
+ #endif /* EMX */
  
        if (string != commands[i].prog)
  	free (string);
+ #ifdef EMX
+       if (rc >= MIN_FATAL_STATUS)
+         ret_code = -1;
+ #endif /* EMX */
      }
  
    execution_count++;
  
+ #ifndef EMX
    /* Wait for all the subprocesses to finish.
       We don't care what order they finish in;
       we know that N_COMMANDS waits will get them all.  */
***************
*** 1998,2003 ****
--- 2093,2101 ----
        }
      return ret_code;
    }
+ #else /* EMX */
+   return ret_code;
+ #endif /* EMX */
  }
  
  /* Find all the switches given to us
***************
*** 3602,3610 ****
--- 3700,3717 ----
    char *specs_file;
    char *p;
  
+ #ifndef EMX
    p = argv[0] + strlen (argv[0]);
    while (p != argv[0] && p[-1] != '/') --p;
+ #else /* EMX */
+   p = _getname (argv[0]);
+ #endif /* EMX */
    programname = p;
+ 
+ #ifdef EMX
+   _response (&argc, &argv);
+   _wildcard (&argc, &argv);
+ #endif /* EMX */
  
    if (signal (SIGINT, SIG_IGN) != SIG_IGN)
      signal (SIGINT, fatal_error);
diff -cr gcc-2.4/objc/Object.h d:gcc-2.4/objc/object.h
*** gcc-2.4/objc/Object.h	Wed May 05 16:52:32 1993
--- d:gcc-2.4/objc/object.h	Mon Jun 14 14:00:54 1993
***************
*** 27,33 ****
  #define __object_INCLUDE_GNU
  
  #include <objc/objc.h>
! #include <objc/typedstream.h>
  
  /*
   * All classes are derived from Object.  As such,
--- 27,33 ----
  #define __object_INCLUDE_GNU
  
  #include <objc/objc.h>
! #include <objc/typedstr.h>
  
  /*
   * All classes are derived from Object.  As such,
diff -cr gcc-2.4/stor-lay.c d:gcc-2.4/stor-lay.c
*** gcc-2.4/stor-lay.c	Tue Apr 13 11:33:24 1993
--- d:gcc-2.4/stor-lay.c	Mon Jun 21 00:31:58 1993
***************
*** 1,3 ****
--- 1,5 ----
+ /* stor-lay.c -- changed for emx by Eberhard Mattes -- Jun 1993 */
+ 
  /* C-compiler utilities for types and variables storage layout
     Copyright (C) 1987, 1988, 1992 Free Software Foundation, Inc.
  
***************
*** 384,391 ****
--- 386,395 ----
  	  register tree dsize = DECL_SIZE (field);
  	  int field_size = TREE_INT_CST_LOW (dsize);
  
+ #ifndef EMX
  	  if (maximum_field_alignment != 0)
  	    type_align = MIN (type_align, maximum_field_alignment);
+ #endif
  
  	  /* A bit field may not span the unit of alignment of its type.
  	     Advance to next boundary if necessary.  */
diff -cr gcc-2.4/toplev.c d:gcc-2.4/toplev.c
*** gcc-2.4/toplev.c	Sat Jun 19 23:34:12 1993
--- d:gcc-2.4/toplev.c	Wed Jun 23 23:23:42 1993
***************
*** 1,3 ****
--- 1,5 ----
+ /* toplev.c -- changed for emx by Eberhard Mattes -- Jun 1993 */
+ 
  /* Top level of GNU C compiler
     Copyright (C) 1987, 1988, 1989, 1992 Free Software Foundation, Inc.
  
***************
*** 1535,1540 ****
--- 1537,1551 ----
    if (dump_base_name == 0)
      dump_base_name = name ? name : "gccdump";
    dump_base_name_length = strlen (dump_base_name);
+ #ifdef EMX
+   {
+     char *tmp = (char *) xmalloc (dump_base_name_length + 1);
+     strcpy (tmp, dump_base_name);
+     dump_base_name = tmp;
+     strip_off_ending (dump_base_name, dump_base_name_length);
+     dump_base_name_length = strlen (dump_base_name);
+   }
+ #endif /* EMX */
  
    parse_time = 0;
    varconst_time = 0;
***************
*** 1617,1623 ****
--- 1628,1638 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 6);
        strcpy (dumpname, dump_base_name);
+ #ifndef EMX
        strcat (dumpname, ".jump");
+ #else /* EMX */
+       strcat (dumpname, ".jp1");
+ #endif /* EMX */
        jump_opt_dump_file = fopen (dumpname, "w");
        if (jump_opt_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1628,1634 ****
--- 1643,1653 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 6);
        strcpy (dumpname, dump_base_name);
+ #ifndef EMX
        strcat (dumpname, ".cse");
+ #else /* EMX */
+       strcat (dumpname, ".cs1");
+ #endif /* EMX */
        cse_dump_file = fopen (dumpname, "w");
        if (cse_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1639,1645 ****
--- 1658,1668 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 6);
        strcpy (dumpname, dump_base_name);
+ #ifndef EMX
        strcat (dumpname, ".loop");
+ #else /* EMX */
+       strcat (dumpname, ".loo");
+ #endif /* EMX */
        loop_dump_file = fopen (dumpname, "w");
        if (loop_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1650,1656 ****
--- 1673,1683 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 6);
        strcpy (dumpname, dump_base_name);
+ #ifndef EMX
        strcat (dumpname, ".cse2");
+ #else /* EMX */
+       strcat (dumpname, ".cs2");
+ #endif /* EMX */
        cse2_dump_file = fopen (dumpname, "w");
        if (cse2_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1661,1667 ****
--- 1688,1698 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 6);
        strcpy (dumpname, dump_base_name);
+ #ifndef EMX
        strcat (dumpname, ".flow");
+ #else /* EMX */
+       strcat (dumpname, ".flo");
+ #endif /* EMX */
        flow_dump_file = fopen (dumpname, "w");
        if (flow_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1672,1678 ****
--- 1703,1713 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 10);
        strcpy (dumpname, dump_base_name);
+ #ifndef EMX
        strcat (dumpname, ".combine");
+ #else /* EMX */
+       strcat (dumpname, ".cmb");
+ #endif /* EMX */
        combine_dump_file = fopen (dumpname, "w");
        if (combine_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1683,1689 ****
--- 1718,1728 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 7);
        strcpy (dumpname, dump_base_name);
+ #ifndef EMX
        strcat (dumpname, ".sched");
+ #else /* EMX */
+       strcat (dumpname, ".sd1");
+ #endif /* EMX */
        sched_dump_file = fopen (dumpname, "w");
        if (sched_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1694,1700 ****
--- 1733,1743 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 6);
        strcpy (dumpname, dump_base_name);
+ #ifndef EMX
        strcat (dumpname, ".lreg");
+ #else /* EMX */
+       strcat (dumpname, ".lre");
+ #endif /* EMX */
        local_reg_dump_file = fopen (dumpname, "w");
        if (local_reg_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1705,1711 ****
--- 1748,1758 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 6);
        strcpy (dumpname, dump_base_name);
+ #ifndef EMX
        strcat (dumpname, ".greg");
+ #else /* EMX */
+       strcat (dumpname, ".gre");
+ #endif /* EMX */
        global_reg_dump_file = fopen (dumpname, "w");
        if (global_reg_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1716,1722 ****
--- 1763,1773 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 8);
        strcpy (dumpname, dump_base_name);
+ #ifndef EMX
        strcat (dumpname, ".sched2");
+ #else /* EMX */
+       strcat (dumpname, ".sd2");
+ #endif /* EMX */
        sched2_dump_file = fopen (dumpname, "w");
        if (sched2_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1727,1733 ****
--- 1778,1788 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 7);
        strcpy (dumpname, dump_base_name);
+ #ifndef EMX
        strcat (dumpname, ".jump2");
+ #else /* EMX */
+       strcat (dumpname, ".jp2");
+ #endif /* EMX */
        jump2_opt_dump_file = fopen (dumpname, "w");
        if (jump2_opt_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1751,1757 ****
--- 1806,1816 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 10);
        strcpy (dumpname, dump_base_name);
+ #ifndef EMX
        strcat (dumpname, ".stack");
+ #else /* EMX */
+       strcat (dumpname, ".stk");
+ #endif /* EMX */
        stack_reg_dump_file = fopen (dumpname, "w");
        if (stack_reg_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 3388,3398 ****
--- 3447,3459 ----
  	       lim - (char *) &environ);
        fflush (stderr);
  
+ #ifndef EMX
  #ifdef USG
        system ("ps -l 1>&2");
  #else /* not USG */
        system ("ps v");
  #endif /* not USG */
+ #endif /* !EMX */
      }
  #endif /* not VMS */
  #endif /* not OS2 */
diff -cr gcc-2.4/varasm.c d:gcc-2.4/varasm.c
*** gcc-2.4/varasm.c	Thu Jun 03 23:52:20 1993
--- d:gcc-2.4/varasm.c	Wed Jun 23 23:23:46 1993
***************
*** 1,3 ****
--- 1,5 ----
+ /* varasm.c -- changed for emx by Eberhard Mattes -- Jun 1993 */
+ 
  /* Output variables, constants and external declarations, for GNU compiler.
     Copyright (C) 1987, 1988, 1989, 1992, 1993 Free Software Foundation, Inc.
  
***************
*** 554,560 ****
--- 556,564 ----
       tree decl;
       char *fnname;
  {
+ #ifndef EMX
    int align;
+ #endif
  
    /* The following code does not need preprocessing in the assembler.  */
  
***************
*** 566,574 ****
--- 570,582 ----
  
  
    /* Tell assembler to move to target machine's alignment for functions.  */
+ #ifndef EMX
    align = floor_log2 (FUNCTION_BOUNDARY / BITS_PER_UNIT);
    if (align > 0)
      ASM_OUTPUT_ALIGN (asm_out_file, align);
+ #else /* EMX */
+   ASM_OUTPUT_ALIGN_CODE (asm_out_file);
+ #endif /* EMX */
  
  #ifdef ASM_OUTPUT_FUNCTION_PREFIX
    ASM_OUTPUT_FUNCTION_PREFIX (asm_out_file, fnname);
***************
*** 1105,1111 ****
--- 1113,1121 ----
  {
    char label[256];
    char *name;
+ #ifndef EMX
    int align;
+ #endif
  
    /* By default, put trampoline templates in read-only data section.  */
  
***************
*** 1116,1124 ****
--- 1126,1138 ----
  #endif
  
    /* Write the assembler code to define one.  */
+ #ifndef EMX
    align = floor_log2 (FUNCTION_BOUNDARY / BITS_PER_UNIT);
    if (align > 0)
      ASM_OUTPUT_ALIGN (asm_out_file, align);
+ #else /* EMX */
+   ASM_OUTPUT_ALIGN_CODE (asm_out_file);
+ #endif /* EMX */
  
    ASM_OUTPUT_INTERNAL_LABEL (asm_out_file, "LTRAMP", 0);
    TRAMPOLINE_TEMPLATE (asm_out_file);
