/* gvgapal.c (emx+gcc) -- Copyright (c) 1987-1993 by Eberhard Mattes */
/*                                   changes 1993 by Johannes Martin */

#include <string.h>
#include <sys/hw.h>
#include <vesa.h>
#include "graph.h"
#include "graph2.h"
#include "graph3.h"
#include "vgaports.h"

void PORT_setpal (const char *pal, int first, int n, int wait_flag)
{
  if (n >= 1 && first >= 0 && first <= 255 && first + n <= 256)
    {
      if (wait_flag)
        _wait01 (IS1_R, 0x08);
      _outp8 (PEL_IW, first);
      _outps8dac (PEL_D, pal, 3 * n);
    }
}

void PORT_getpal(char *pal, int first, int n)
{
  int i, j;

  /* select palette register */
  _outp8(PEL_IR, first);

  for(j = 0; j < n; j++)
    {
      for(i = 0; i < 10; i++) ;   /* delay (minimum 240ns) */
      *(pal++) = (int) _inp8(PEL_D);
      for(i = 0; i < 10; i++) ;   /* delay (minimum 240ns) */
      *(pal++) = (int) _inp8(PEL_D);
      for(i = 0; i < 10; i++) ;   /* delay (minimum 240ns) */
      *(pal++) = (int) _inp8(PEL_D);
    }
}

void MEM_setpal (const char *pal, int first, int n, int wait_flag)
{
  memcpy(_g_vpal + 3 * first, pal, 3 * n);
}

void MEM_getpal(char *pal, int first, int n)
{
  memcpy(pal, _g_vpal + 3 * first, 3 * n);
}

void DUMMY_setpal (const char *pal, int first, int n, int wait_flag)
{
}

void DUMMY_getpal(char *pal, int first, int n)
{
}

void g_setpal (const char *pal, int first, int n, int wait_flag)
{
  GLOCK;
  _g_setpal(pal, first, n, wait_flag);
  GUNLOCK;
}

void g_getpal(char *pal, int first, int n)
{
  GLOCK;
  _g_getpal(pal, first, n);
  GUNLOCK;
}
