#ifndef FALSE
  #define FALSE 0
#endif

#ifndef TRUE
  #define TRUE 1
#endif

typedef unsigned char  VESACHAR, *PVESACHAR;
typedef unsigned short VESAWORD, *PVESAWORD;
typedef int            VESABOOL;
typedef void           *VESAPTR;

typedef VESABOOL (*VESASET)(VESACHAR Window, VESAWORD Address);
typedef VESABOOL (*VESAGET)(VESACHAR Window, PVESAWORD Address);
typedef void  (*VESASWITCH)(int Restore);

typedef struct
  {
    VESAWORD Version;
    VESACHAR *OEMName;
    VESAWORD *Modes;
  } VESAINFO, *PVESAINFO;

typedef struct
  {
    VESAWORD ModeAttributes;
    VESACHAR WindowAAttributes;
    VESACHAR WindowBAttributes;
    VESAWORD WindowGranularity;
    VESAWORD WindowSize;
    VESAPTR  WindowAStart;
    VESAPTR  WindowBStart;
    VESASET  SetWindowFunc;
    VESAGET  GetWindowFunc;
    VESAWORD BytesPerScanline;
    VESAWORD Width;
    VESAWORD Height;
    VESACHAR CharacterWidth;
    VESACHAR CharacterHeight;
    VESACHAR NumberOfMemoryPlanes;
    VESACHAR NumberOfBitsPerPixel;
    VESACHAR NumberOfBanks;
    VESACHAR MemoryModelType;
    VESACHAR SizeOfBank;
    VESACHAR NumberofPages;
    /* ... */
    VESACHAR RedMaskSize;
    VESACHAR RedMaskPosition;
    VESACHAR GreenMaskSize;
    VESACHAR GreenMaskPosition;
    VESACHAR BlueMaskSize;
    VESACHAR BlueMaskPosition;
    VESACHAR ReservedMaskSize;
    VESACHAR ReservedMaskPosition;
  } VESAMODEINFO, *PVESAMODEINFO;

VESABOOL DosVesaGetInfo(PVESAINFO pVesaInfo);
VESABOOL DosVesaGetModeInfo(VESAWORD Mode, PVESAMODEINFO pVesaModeInfo);

VESABOOL DosVesaSetMode(VESAWORD Mode);
VESABOOL DosVesaGetMode(PVESAWORD Mode);

VESABOOL DosVesaSetWindow(VESACHAR Window, VESAWORD Address);
VESABOOL DosVesaGetWindow(VESACHAR Window, PVESAWORD Address);

VESABOOL DosVesaSetScanlineLength(VESAWORD NumberOfPixels);
VESABOOL DosVesaGetScanlineLength(PVESAWORD BytesPerScanline,
                                  PVESAWORD NumberOfPixels,
                                  PVESAWORD NumberOfScanlines);

VESABOOL OS2VesaGetInfo(PVESAINFO pVesaInfo);
VESABOOL OS2VesaGetModeInfo(VESAWORD Mode, PVESAMODEINFO pVesaModeInfo);

VESABOOL OS2VesaSetMode(VESAWORD Mode);
VESABOOL OS2VesaGetMode(PVESAWORD Mode);

VESABOOL OS2VesaSetWindow(VESACHAR Window, VESAWORD Address);
VESABOOL OS2VesaGetWindow(VESACHAR Window, PVESAWORD Address);

VESABOOL OS2VesaSetScanlineLength(VESAWORD NumberOfPixels);
VESABOOL OS2VesaGetScanlineLength(PVESAWORD BytesPerScanline,
                                  PVESAWORD NumberOfPixels,
                                  PVESAWORD NumberOfScanlines);

VESABOOL OS2VesaSetSwitchFunc(VESASWITCH SwitchFunc);
VESABOOL OS2VesaLockScreen   (VESACHAR wait);
VESABOOL OS2VesaUnlockScreen (void);

#define VesaGetInfo(pVesaInfo)                                        \
  (_osmode == OS2_MODE ? OS2VesaGetInfo(pVesaInfo) :                  \
                         DosVesaGetInfo(pVesaInfo))
#define VesaGetModeInfo(Mode, pVesaModeInfo)                          \
  (_osmode == OS2_MODE ? OS2VesaGetModeInfo(Mode, pVesaModeInfo) :    \
                         DosVesaGetModeInfo(Mode, pVesaModeInfo))

#define VesaSetMode(Mode)                                             \
  (_osmode == OS2_MODE ? OS2VesaSetMode(Mode) : DosVesaSetMode(Mode))
#define VesaGetMode(Mode)                                             \
  (_osmode == OS2_MODE ? OS2VesaGetMode(Mode) : DosVesaGetMode(Mode))

#define VesaSetWindow(Window, Address)                                \
  (_osmode == OS2_MODE ? OS2VesaSetWindow(Window, Address) :          \
                         DosVesaSetWindow(Window, Address))
#define VesaGetWindow(Window, Address)                                \
  (_osmode == OS2_MODE ? OS2VesaGetWindow(Window, Address) :          \
                         DosVesaGetWindow(Window, Address))

#define VesaSetScanlineLength(NumberOfPixels)                         \
  (_osmode == OS2_MODE ? OS2VesaSetScanlineLength(NumberOfPixels) :   \
                         DosVesaSetScanlineLength(NumberOfPixels))
#define VesaGetScanlineLength(BPS, NOP, NOS)                          \
  (_osmode == OS2_MODE ? OS2VesaGetScanlineLength(BPS, NOP, NOS) :    \
                         DosVesaGetScanlineLength(BPS, NOP, NOS))

#define VesaSetSwitchFunc(SwitchFunc)                                 \
  (_osmode == OS2_MODE ? OS2VesaSetSwitchFunc(SwitchFunc) : TRUE)
#define VesaLockScreen(wait)                                          \
  (_osmode == OS2_MODE ? OS2VesaLockScreen(wait) : TRUE)
#define VesaUnlockScreen()                                            \
  (_osmode == OS2_MODE ? OS2VesaUnlockScreen() : TRUE)
