/* defs.h (emx+gcc) */

/* Various definitions for emx utilities.

Copyright (c) 1992, 1993 Eberhard Mattes

This file is part of emxomf.

This module is free software; you can redistribute it and/or modify it
under the terms of the GNU Library General Public License as published
by the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.  This module is distributed in
the hope that it will be useful, but WITHOUT ANY WARRANTY; without
even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Library General Public License for
more details.  You should have received a copy of the GNU Library
General Public License along with this library; if not, write to the
Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

As a special exception, emxomf can be distributed with emx.  */

#define FALSE 0
#define TRUE  1

#define NORETURN volatile

#define N_EXT           0x01
#define N_ABS           0x02
#define N_TEXT          0x04
#define N_DATA          0x06
#define N_BSS           0x08

#define N_SETA          0x14
#define N_SETT          0x16

#define N_GSYM          0x20
#define N_FUN           0x24
#define N_STSYM         0x26
#define N_LCSYM         0x28
#define N_RSYM          0x40
#define N_SLINE         0x44
#define N_SO            0x64
#define N_LSYM          0x80
#define N_SOL           0x84
#define N_PSYM          0xa0
#define N_LBRAC         0xc0
#define N_RBRAC         0xe0

#define N_IMP1          0x68
#define N_IMP2          0x6a


typedef unsigned char byte;
typedef unsigned short word;
typedef unsigned long dword;

struct reloc
{
  dword address;
  dword symbolnum:24;
  dword pcrel:1;
  dword length:2;
  dword ext:1;
  dword unused:4;
};


struct nlist
{
  dword string;
  byte type;
  byte other;
  word desc;
  dword value;
};
