/* access.c (emx+gcc) -- Copyright (c) 1990-1993 by Eberhard Mattes */

#include <sys/emx.h>
#include <string.h>
#include <io.h>
#include <errno.h>

int access (const char *name, int mode)
{
  int a, i, slash;
  char *tmp;

  slash = FALSE;
  i = strlen (name);
  if (i > 1 && (name[i-1] == '\\' || name[i-1] == '/') &&
      (name[i-2] != '\\' && name[i-2] != '/' && name[i-2] != ':'))
    {
      slash = TRUE;
      tmp = alloca (i);
      memcpy (tmp, name, i);
      tmp[i-1] = 0;
      name = tmp;
    }
  a = __chmod (name, 0, 0);
  if (a < 0)
    return (-1);
  if (a & _A_SUBDIR)        /* directories are always readable and writable */
    return (0);
  if (slash)
    {
      errno = ENOTDIR;
      return (-1);
    }
  if (a & _A_VOLID)
    {
      errno = ENOENT;
      return (-1);
    }
  if ((mode & 2) && (a & _A_RDONLY))
    {
      errno = EACCES;
      return (-1);
    }
  return (0);
}
