/* system.c (emx+gcc) -- Copyright (c) 1990-1993 by Eberhard Mattes */

#include <stdlib.h>
#include <string.h>
#include <process.h>
#include <io.h>
#include <errno.h>

int system (const char *name)
{
  int rc;
  const char *sh;

  sh = getenv ("COMSPEC");
  if (sh == NULL)
    {
      errno = ENOENT;
      return (-1);
    }
  if (name == NULL)   /* Check for command interpreter */
    return (access (sh, 0) == 0);
  if (*name == 0)
    rc = spawnlp (P_WAIT, sh, sh, NULL);
  else
    rc = spawnlp (P_WAIT, sh, sh, "/c", name, NULL);
  return (rc);
}
